#ifndef CLEANSCENE_H
#define CLEANSCENE_H

#include <optixu/optixpp_namespace.h>
#include <sutil.h>
#include <SampleScene.h>


#include "random.h"

using namespace optix;



class Helsinki : public SampleScene
{
    static const int ENTRY_POINT_BIDIR_PATH_TRACE = 0;
    static const int ENTRY_POINT_BIDIR_FINALISE = 1;
    static const int DEFAULT_PROGRAM_ID = 0;
    static const int DEFAULT_ENTRY_POINT = ENTRY_POINT_BIDIR_PATH_TRACE;
public:
  // Set the actual render parameters below in main().
  Helsinki();

  virtual void   initScene( InitialCameraData& camera_data );
  virtual void   trace( const RayGenCameraData& camera_data );
  virtual Buffer getOutputBuffer();

  void   setDimensions( const unsigned int w, const unsigned int h ) { m_width = w; m_height = h; }

private:
  // Should return true if key was handled, false otherwise.
  virtual bool keyPressed(unsigned char key, int x, int y);
  void createGeometry(InitialCameraData& camera_data, const std::string &ptx_path);

  void loadScene(const std::string& path);

  Program        m_pgram_bounding_box;
  Program        m_pgram_intersection;

  GeometryGroup m_geometry_group;

  Material m_diffuseMaterial;
  Program m_closestHitProgram;
  unsigned int m_currentEntryPoint;

  unsigned int   m_num_samples;
  unsigned int   m_width;
  unsigned int   m_height;
  unsigned int   m_frame;
};

#endif // CLEANSCENE_H
